import RPi.GPIO as GPIO # Import Raspberry Pi GPIO library
import requests
import datetime
import config

now = datetime.datetime.now()

fh = open("/home/pi/button_log.txt", "a")
fh.write('Button monitoring process started at ' + now.strftime("%Y-%m-%d %H:%M") + '\r\n')

url = 'https://selkirkhome.co.za/intercom/db_send_pushed_notification.php'
params = {
    'intercom_id':config.getIntercomID(),
    'title':'Ding Dong',
    'message':'Somebody has pressed the doorbell'
}

def button_callback(channel):
    resp = requests.post(url=url, data=params)
    fh.write('Button pushed at ' + now.strftime("%Y-%m-%d %H:%M") + ' result: ' + resp.text + '\r\n')
    
GPIO.setwarnings(False) # Ignore warning for now
GPIO.setmode(GPIO.BOARD) # Use physical pin numbering
GPIO.setup(11, GPIO.IN, pull_up_down=GPIO.PUD_UP) # Set pin 11 to be an input pin and set initial value to be pulled high (on)
GPIO.setup(13, GPIO.OUT) # Set pin 13 to be an output
GPIO.setup(15, GPIO.OUT) # Set pin 15 to be an output
chan_list = (13,15)
GPIO.output(chan_list, GPIO.HIGH) # Set pins 13 and 15 as high by default


GPIO.add_event_detect(11,GPIO.RISING,callback=button_callback, bouncetime=3000) # Setup event on pin 11 rising edge

#function to check internet connectivity
import socket
REMOTE_SERVER = "www.google.com"
def is_connected(hostname):
  try:
    # see if we can resolve the host name -- tells us if there is
    # a DNS listening
    host = socket.gethostbyname(hostname)
    # connect to the host -- tells us if the host is actually
    # reachable
    s = socket.create_connection((host, 80), 2)
    return True
  except:
     pass
  return False

import time 
while True:
    if is_connected(REMOTE_SERVER):
        GPIO.output(15,GPIO.LOW)
    else:
        GPIO.output(15,GPIO.HIGH)

    time.sleep(30)

fh.close()
GPIO.cleanup() # Clean up

